books/urls.py
from django.urls import path

from books import views
app_name = 'books'
urlpatterns = [
    path('book/<int:pk>/edit/', views.BookUpdate.as_view(), name='edit'),
    path('book/<int:book_id>/', views.BookDetailView.as_view(), name='detail'),
]

library_django/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('users.urls')),
    path('', include('books.urls')),
]

users/urls.py
from django.urls import path

from users import views

app_name = 'users'
urlpatterns = [
    path('', views.UserIndexView.as_view(), name='index'),
    path('user/<int:user_id>/books/', views.UserBooksView.as_view(),
         name='books'),
]

books/models.py
from django.db import models


class Book(models.Model):
    title = models.CharField(max_length=100)
    author = models.CharField(max_length=100)
    publication_date = models.DateField()
    created = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.title

users/models.py
from django.db import models

from books.models import Book


class User(models.Model):
    first_name = models.CharField(max_length=30)
    last_name = models.CharField(max_length=40)
    email = models.EmailField(null=True, blank=True)
    date_of_birth = models.DateField(null=True)
    books = models.ManyToManyField(Book, blank=True)
    created = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return f'{self.first_name} {self.last_name}'

books/forms.py
from django import forms
from books.models import Book


class BookCreationForm(forms.ModelForm):

    class Meta:
        model = Book
        fields = ('title', 'author', 'publication_date')


class BookUpdateForm(forms.ModelForm):
    title = forms.CharField(required=False)
    author = forms.CharField(required=False)
    publication_date = forms.DateField(required=False)

    class Meta:
        model = Book
        fields = ('title', 'author', 'publication_date')

users/forms.py
from django.forms import ModelForm
from users.models import User


class UserCreationForm(ModelForm):

    class Meta:
        model = User
        fields = ('first_name', 'last_name', 'email', 'date_of_birth')

books/views.py
from django.shortcuts import render, get_object_or_404
from django.urls import reverse
from django.views.generic.detail import DetailView
from django.views.generic.edit import UpdateView

from books.forms import BookUpdateForm
from books.models import Book


class BookUpdate(UpdateView):
    model = Book
    form_class = BookUpdateForm
    template_name = 'books/edit.html'

    def get_success_url(self):
        return reverse(
            'books:detail',
            kwargs={'book_id': self.object.id}
        )


class BookDetailView(DetailView):

    def get(self, request, *args, **kwargs):
        book = get_object_or_404(Book, pk=kwargs['book_id'])
        context = {'book': book}
        return render(request, 'books/detail.html', context)

users/views.py
from django.shortcuts import render, redirect
from django.views import View

from books.forms import BookCreationForm
from books.models import Book
from users.forms import UserCreationForm
from users.models import User


class UserIndexView(View):
    form_class = UserCreationForm
    template_name = 'users/index.html'

    def get(self, request, *args, **kwargs):
        users = User.objects.all()
        form = self.form_class()
        return render(
            request,
            self.template_name,
            {'form': form, 'users': users}
        )

    def post(self, request, *args, **kwargs):
        form = self.form_class(request.POST)
        if form.is_valid():
            form.save(commit=True)
            return redirect('users:index')

        return render(request, self.template_name, {'form': form})


class UserBooksView(View):
    form_class = BookCreationForm
    template_name = 'users/books.html'

    def get(self, request, *args, **kwargs):
        user_id = kwargs.get('user_id')
        books = Book.objects.filter(user__id=user_id)
        form = self.form_class()
        return render(
            request,
            self.template_name,
            {'form': form, 'books': books}
        )

    def post(self, request, *args, **kwargs):
        user_id = kwargs.get('user_id')
        user = User.objects.get(id=user_id)
        form = self.form_class(request.POST)
        if form.is_valid():
            book = form.save(commit=False)
            book.user = user
            book.save()
            user.books.add(book.id)
            user.save()
            return redirect('users:index')

        return render(request, self.template_name, {'form': form})

books/templates/books/detail.html
<h3>Book detail</h3>
<h4>{{book.title}}</h4>
<h5>{{book.author}}</h5>

books/templates/books/edit.html
    <h2>Edit book</h2>
<h4>Current title: {{book.title}}</h4>
    <h5>Current author: {{book.author}}</h5>
    <h5>Current publication_date: {{book.publication_date}}</h5>

    <form method="POST" class="post-form">{% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="save btn btn-default">Edit</button>
    </form>

users/templates/users/books.html
{% if books %}
    <ul>
    {% for book in books %}
        <li><a href="{% url 'books:edit' pk=book.id %}">{{ book.title }} {{book.author }}</a></li>
    {% endfor %}
    </ul>
{% else %}
    <p>User isn't reading any books now</p>
{% endif %}

    <h2>New user's book</h2>
    <form method="POST" class="post-form">{% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="save btn btn-default">Add user's book</button>
    </form>

users/templates/users/index.html
{% if users %}
    <ul>
    {% for user in users %}
        <li><a href="{% url 'users:books' user_id=user.id %}">{{ user.first_name }} {{user.last_name }}</a></li>
        {{ user.date_of_birth}} {{ user.email }}
    {% endfor %}
    </ul>
{% else %}
    <p>No users are available.</p>
{% endif %}

    <h2>New user</h2>
    <form method="POST" class="post-form">{% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="save btn btn-default">Add user</button>
    </form>